<?php
/**
 * Crypto-Processing Payment Model
 */
class ModelExtensionPaymentCprocessing extends Model {

	/** @var CprocessingLibrary $cprocessing */
	private $cprocessing;

	/**
	 * Crypto-Processing Payment Model Construct
	 * @param Registry $registry
	 */
	public function __construct($registry) {
		parent::__construct($registry);
		$this->load->language('extension/payment/cprocessing');
		$this->cprocessing = new Cprocessing($registry);
	}

	/**
	 * Returns the Crypto-Processing Payment Method if available
	 * @param  array $address Customer billing address
	 * @return array|void Crypto-Processing Payment Method if available
	 */
	public function getMethod($address)	{
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "zone_to_geo_zone WHERE geo_zone_id = '" . (int)$this->cprocessing->setting('geo_zone_id') . "' AND country_id = '" . (int)$address['country_id'] . "' AND (zone_id = '" . (int)$address['zone_id'] . "' OR zone_id = '0')");

		// All Geo Zones configured or address is in configured Geo Zone
		if (!$this->config->get('cprocessing_geo_zone_id') || $query->num_rows) {
			return array(
				'code'	   => 'cprocessing',
				'title'	  => $this->language->get('text_title'),
				'terms'	  => '',
				'sort_order' => $this->cprocessing->setting('sort_order')
			);
		}
	}
}
